/*

Copyright (c) 2013, Embedded Adventures, www.embeddedadventures.com
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

- Redistributions of source code must retain the above copyright notice,
  this list of conditions and the following disclaimer.

- Redistributions in binary form must reproduce the above copyright
  notice, this list of conditions and the following disclaimer in the
  documentation and/or other materials provided with the distribution.

- Neither the name of Embedded Adventures nor the names of its contributors
  may be used to endorse or promote products derived from this software
  without specific prior written permission.
 
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF 
THE POSSIBILITY OF SUCH DAMAGE.

Contact us at admin@embeddedadventures.com

*/
#include "ea_dsp7s04.h"
#include "pic_serial.h"
#include "i2c.h"


void ea_dsp7s04b_setup_io(void) {

	i2c_setup_io();
	
}

void ea_dsp7s04b_init(void) {
	
	//i2c_init();
}	



void ea_dsp7s04b_set_dot(uns8 position) {
	i2c_start();
	i2c_send_byte(EA_DSP7S04_ADDR);
	i2c_send_byte(0x03);
	i2c_send_byte(position);
	i2c_send_byte(0x01);
	i2c_stop();		

}	

void ea_dsp7s04b_clear_dot(uns8 position) {
	i2c_start();
	i2c_send_byte(EA_DSP7S04_ADDR);
	i2c_send_byte(0x03);
	i2c_send_byte(position);
	i2c_send_byte(0x00);
	i2c_stop();	

}	
void ea_dsp7s04b_set_colon(void) {
	i2c_start();
	i2c_send_byte(EA_DSP7S04_ADDR);
	i2c_send_byte(0x04);
	i2c_send_byte(0x01);
	i2c_stop();	

}	

void ea_dsp7s04b_clear_colon(void) {
	i2c_start();
	i2c_send_byte(EA_DSP7S04_ADDR);
	i2c_send_byte(0x04);
	i2c_send_byte(0x00);
	i2c_stop();
}	


void ea_dsp7s04b_print_str(char *str) {

uns8 count;
	i2c_start();
	i2c_send_byte(EA_DSP7S04_ADDR);
	i2c_send_byte(0x01);
	for( count = 0; count < 4; count++ ) {
		i2c_send_byte(str[count]);
	}
	i2c_stop();
}
	
void ea_dsp7s04b_put_raw(uns8 pos, uns16 data) {
	i2c_start();
	i2c_send_byte(EA_DSP7S04_ADDR);
	i2c_send_byte(0x02);
	i2c_send_byte(pos);
	i2c_send_byte(data >> 8);
	i2c_send_byte(data & 0xff);
	i2c_stop();
}

void ea_dsp7s04b_test_mode(uns8 on) {
	i2c_start();
	i2c_send_byte(EA_DSP7S04_ADDR);
	i2c_send_byte(0x00);
	i2c_send_byte(on);
	i2c_stop();
	
}
		
void ea_dsp7s04b_clear(void) {
	i2c_start();
	i2c_send_byte(EA_DSP7S04_ADDR);
	i2c_send_byte(0x05);
	i2c_stop();
	
}	

void ea_dsp7s04b_set_level(uns8 level) {
	i2c_start();
	i2c_send_byte(EA_DSP7S04_ADDR);
	i2c_send_byte(0x06);
	i2c_send_byte(level);
	i2c_stop();
}